(*pp ocamlrun ../common/version_filter -pp "camlp4o -impl" *)
(************************************************************
 *
 * A part of Regexp/OCaml module.
 * 
 * (c) 2002-2003 Yutaka Oiwa. All Rights Reserved.
 *
 * This file is distributed under the terms of the Q Public
 * License version 1.0.
 *
 ************************************************************)
(* $Id: once_construct.ml 139 2009-09-21 06:58:26Z yutaka $ *)

open Printf

#if 3.06 | 3.07pre | 3.07 | 3.07_5 | 3.07_19 | 3.09pre | 3.09
open Pcaml
#else
open Camlp4.PreCast
open Syntax
open Ast
#endif

#load "pa_extend.cmo";;
#load "q_MLast.cmo";;

let package = "onceexpr"

let _ =
  EXTEND
#if 3.06 | 3.07pre | 3.07 | 3.07_5 | 3.07_19 | 3.09pre | 3.09
#else
         Gram
#endif
    expr: LEVEL "apply"
    [[ "once";
       r = SELF ->
	 let i = Declare_once.gensym ~package in
	 Declare_once.declare ~package i (Declare_once.Expr <:expr< lazy $r$ >>);
	 <:expr< Lazy.force $lid:i$ >>
     ]]
    ;
END
